﻿// メッセージボックスサンプル(フック・サブクラス化・高DPI)
// Visual C++ 2013 32/64bit
// Windows 10のバージョン設定(Windows10以前は0を指定)

#define WIN10VERDEF	0	//1703以降の場合Windows自身が自動的に対応

#include <windows.h>
#include <CommCtrl.h>
#include <tchar.h>

#if	WIN10VERDEF < 1703

#pragma comment (lib, "comctl32.lib")

#if 1500 < _MSC_VER
#include <shellscalingapi.h>

# pragma comment(lib, "Shcore.lib")
#else
#define WM_DPICHANGED                   0x02E0
typedef enum MONITOR_DPI_TYPE {
	MDT_EFFECTIVE_DPI = 0,
	MDT_ANGULAR_DPI = 1,
	MDT_RAW_DPI = 2,
	MDT_DEFAULT = MDT_EFFECTIVE_DPI
} MONITOR_DPI_TYPE;

#endif

#ifndef _DPI_AWARENESS_CONTEXTS_
DECLARE_HANDLE(DPI_AWARENESS_CONTEXT);
#endif

typedef HRESULT(_stdcall *GetDpiForMonitorFunc)(HMONITOR, MONITOR_DPI_TYPE, UINT *, UINT *);
typedef HRESULT(_stdcall* EnableNonClientDpiScalingFunc)(HWND);
typedef HRESULT(_stdcall* SetThreadDpiAwarenessContextFunc)(DPI_AWARENESS_CONTEXT);
typedef BOOL(_stdcall *SetProcessDPIAwareFunc)(VOID);

static HMODULE hModUser32;
static EnableNonClientDpiScalingFunc NCCfunc = 0;
static SetThreadDpiAwarenessContextFunc ThreadAwareFunc = 0;

#ifndef _DPI_AWARENESS_CONTEXTS_

typedef enum _DPI_AWARENESS {
	DPI_AWARENESS_INVALID = -1,
	DPI_AWARENESS_UNAWARE = 0,
	DPI_AWARENESS_SYSTEM_AWARE = 1,
	DPI_AWARENESS_PER_MONITOR_AWARE = 2,
} DPI_AWARENESS;

#define DPI_AWARENESS_CONTEXT_UNAWARE              ((DPI_AWARENESS_CONTEXT)-1)
#define DPI_AWARENESS_CONTEXT_SYSTEM_AWARE         ((DPI_AWARENESS_CONTEXT)-2)
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE    ((DPI_AWARENESS_CONTEXT)-3)
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2 ((DPI_AWARENESS_CONTEXT)-4)
#define DPI_AWARENESS_CONTEXT_UNAWARE_GDISCALED	   ((DPI_AWARENESS_CONTEXT)-5)

#endif

HHOOK MyHookHandle;
HWND hDlgMessageBox = 0;

static HFONT hFont = 0;
static int nowDPIx = 96;
static int nowDPIy = 96;
static UINT nowScale = 100;
static UINT initScale = 100;
static int height;
static HMODULE hMod;
static GetDpiForMonitorFunc func = 0;
static SIZE baseUnit;


struct DLG_CHILD_SCALE{
	HWND hDlg;
	SIZE unit;
	UINT oldScale;
	UINT newScale;
	HFONT hFont;
};
//	フック関数
LRESULT CALLBACK MsgBoxHookProc(int nCode, WPARAM wParam, LPARAM lParam);
//	メッセージボックスのサブクラス化
LRESULT CALLBACK MsgBoxSubclassProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam, UINT_PTR uIdSubclass, DWORD_PTR dwRefData);
//	DPIスケールの変更
HFONT MsgBoxscaleChange(HWND hDlg, int nowScale, int oldScale, SIZE& baseUnit, HFONT hFont);
//	メッセージボックス内の各ウィンドウ(コントロールの移動及び大きさの変更)
BOOL CALLBACK EnumWndProc(HWND hWnd, LPARAM lParam);
BOOL GetActualDialogBaseUnits(HWND hDlg, SIZE *baseUnit);

int win10ver2(void);
int WIN10VER;

#endif	//	WIN10VERDEF < 1703

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, TCHAR* lpsCmdLine, int nCmdShow){

#if	WIN10VERDEF < 1703
	WIN10VER = win10ver2();
	hModUser32 = LoadLibrary(L"User32.dll");

	NCCfunc = (EnableNonClientDpiScalingFunc)GetProcAddress(hModUser32, "EnableNonClientDpiScaling");
	if (WIN10VER == 1607)	//	AnniversaryUpdate
		NCCfunc = (EnableNonClientDpiScalingFunc)GetProcAddress(hModUser32, "EnableNonClientDpiScaling");
	else
		NCCfunc = 0;

	ThreadAwareFunc = (SetThreadDpiAwarenessContextFunc)GetProcAddress(hModUser32, "SetThreadDpiAwarenessContext");

	if (ThreadAwareFunc){
		if (WIN10VER<1703)
			(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE);
		if (1703 <= WIN10VER && WIN10VER<1809)
			(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2);
		if (1809 <= WIN10VER)
			(*ThreadAwareFunc)(DPI_AWARENESS_CONTEXT_UNAWARE_GDISCALED);
	}
	else{	//	Windows Vista以降
		SetProcessDPIAwareFunc ProcessAwareFunc = (SetProcessDPIAwareFunc)GetProcAddress(hModUser32, "SetProcessDPIAware");
		if (ProcessAwareFunc)
			(*ProcessAwareFunc)();
	}
	if (WIN10VER<1703)	//	Windows 10 Version 1703より古い場合はフック関数を使用する。
		MyHookHandle = SetWindowsHookEx(WH_CALLWNDPROC, MsgBoxHookProc, NULL, GetCurrentThreadId());
#endif //WIN10VERDEF < 1703
#if WIN10VERDEF < 1703
	if (WIN10VER<1703)	//	Windows 10 Version 1703より古い場合はフック関数を使用する。
		MyHookHandle = SetWindowsHookEx(WH_CALLWNDPROC, MsgBoxHookProc, NULL, GetCurrentThreadId());
#endif //WIN10VERDEF < 1703

	if (MessageBox(0, TEXT("Hello! 漢字"), TEXT("Message"), MB_YESNO | MB_ICONEXCLAMATION) == IDYES){

		MessageBox(0, _TEXT("はいが押されました"), _TEXT("戻り値"), MB_OK);
	}

#if WIN10VERDEF < 1703
	if (hModUser32)
		FreeLibrary(hModUser32);
#endif // WIN10VERDEF < 1703
	return 0;
}

#if WIN10VERDEF < 1703

//	フック関数
LRESULT CALLBACK MsgBoxHookProc(int nCode, WPARAM wParam, LPARAM lParam){
	// コード判断
	if (nCode >= 0){
		if (nCode == HC_ACTION){	//	システムがウィンドウをアクティブ化
			CWPSTRUCT* pcwp = (CWPSTRUCT*)lParam;
			HWND hDlg = pcwp->hwnd;
			hDlgMessageBox = hDlg;
			if (pcwp->message == WM_INITDIALOG){
				TCHAR name[16];
				GetClassName(hDlg, name, sizeof(name) / sizeof(name[0]));
				if (_tcscmp(name, _TEXT("#32770")) == 0)// MessageBoxのクラス名
					SetWindowSubclass(hDlg, MsgBoxSubclassProc, 1, 0);
				// フック解除
				UnhookWindowsHookEx(MyHookHandle);
			}
		}
	}
	return CallNextHookEx(MyHookHandle, nCode, wParam, lParam);
}
//	メッセージボックスのサブクラス化
LRESULT CALLBACK MsgBoxSubclassProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam, UINT_PTR uIdSubclass, DWORD_PTR dwRefData){
	if (uMsg == UINT(WM_INITDIALOG)){
		HMONITOR hMonitor = MonitorFromWindow(hDlg, MONITOR_DEFAULTTONULL);
		hMod = LoadLibrary(L"Shcore.dll");
		func = (GetDpiForMonitorFunc)GetProcAddress(hMod, "GetDpiForMonitor");
		UINT hDPI, vDPI;
		if (func)
			(*func)(hMonitor, MDT_EFFECTIVE_DPI, &hDPI, &vDPI);
		else{
			HDC hdc = GetDC(NULL);	//	ディスクトップ
			hDPI = GetDeviceCaps(hdc, LOGPIXELSX);
			vDPI = GetDeviceCaps(hdc, LOGPIXELSY);
		}
		nowDPIx = hDPI;
		nowDPIy = vDPI;
		nowScale = MulDiv(nowDPIx, 100, 96);
		GetActualDialogBaseUnits(hDlg, &baseUnit);
		UINT oldScale = nowScale;
		hFont = MsgBoxscaleChange(hDlg, nowScale, oldScale, baseUnit, hFont);

		return DefSubclassProc(hDlg, uMsg, wParam, lParam);
	}
	if (uMsg == UINT(WM_DPICHANGED)){
		UINT oldScale = nowScale;
		nowDPIx = LOWORD(wParam);
		nowDPIy = HIWORD(wParam);
		nowScale = MulDiv(nowDPIx, 100, 96);
		hFont = MsgBoxscaleChange(hDlg, nowScale, oldScale, baseUnit, hFont);
		return 0;
	}
	if (uMsg == UINT(WM_NCCREATE)) {	//	Windows 10 Version 1607のみ呼び出す
		if (NCCfunc)
			(*NCCfunc)(hDlg);
		return DefWindowProc(hDlg, uMsg, wParam, lParam);
	}
	switch (uMsg) {
	case (UINT)WM_DESTROY:
		RemoveWindowSubclass(hDlg, MsgBoxSubclassProc, 1);
		break;
	default:
		break;
	}
	return DefSubclassProc(hDlg, uMsg, wParam, lParam);
}

//	DPIスケールの変更
HFONT MsgBoxscaleChange(HWND hDlg, int nowScale, int oldScale, SIZE& baseUnit, HFONT hFont){
	LOGFONT lf;
	HWND hWnd = GetWindow(hDlg, GW_CHILD);

	HDC hdc = GetDC(hWnd);
	HFONT hfont9 = (HFONT)SendMessage(hWnd, WM_GETFONT, 0, 0);
	GetObject(hfont9, sizeof(LOGFONT), &lf);
	int height;
	height = lf.lfHeight * 100 / oldScale;
	lf.lfHeight = (height)*nowScale;
	lf.lfHeight /= 100;
	HFONT hFont2 = CreateFontIndirect(&lf);
	LOGFONT lfont;
	HFONT hFontOld = (HFONT)SelectObject(hdc, hFont2);

	TEXTMETRIC metrics;
	GetTextMetrics(hdc, &metrics);
	SelectObject(hdc, hFontOld);

	HFONT htemp = (HFONT)SendMessage(hDlg, WM_GETFONT, 0, 0);
	GetObject(htemp, sizeof(LOGFONT), &lfont);
	ReleaseDC(hDlg, hdc);

	RECT rc;
	GetClientRect(hDlg, &rc);
	int w = rc.right - rc.left;
	int h = rc.bottom - rc.top;
	w = MulDiv(w, nowScale, oldScale);
	h = MulDiv(h, nowScale, oldScale);

	rc.left = 0;
	rc.top = 0;
	rc.right = w;
	rc.bottom = h;

	LONG style = GetWindowLong(hDlg, GWL_STYLE);
	AdjustWindowRectEx(&rc, style, FALSE, 0);

	SetWindowPos(hDlg, NULL, 0, 0, rc.right - rc.left, rc.bottom - rc.top, SWP_NOMOVE | SWP_NOZORDER);

	DLG_CHILD_SCALE d;
	d.hDlg = hDlg;
	d.hFont = hFont2;
	d.newScale = nowScale;
	d.oldScale = oldScale;
	d.unit = baseUnit;

	EnumChildWindows(hDlg, EnumWndProc, (LPARAM)&d);
	InvalidateRect(hDlg, NULL, FALSE);
	UpdateWindow(hDlg);
	if (hFont)
		DeleteObject(hFont);
	return hFont = hFont2;
}

//	メッセージボックス内の各ウィンドウ(コントロールの移動及び大きさの変更)
BOOL CALLBACK EnumWndProc(HWND hWnd, LPARAM lParam){
	POINT pt;
	DLG_CHILD_SCALE* d = (DLG_CHILD_SCALE*)lParam;
	pt.x = 0;
	pt.y = 0;
	ClientToScreen(hWnd, &pt);
	ScreenToClient(d->hDlg, &pt);
	RECT rc;
	GetClientRect(hWnd, &rc);
	int cx, cy, w, h;
	cx = MulDiv(pt.x, 4, d->unit.cx);
	cy = MulDiv(pt.y, 8, d->unit.cy);

	cx = MulDiv(cx, d->newScale, d->oldScale);
	cy = MulDiv(cy, d->newScale, d->oldScale);

	cx = MulDiv(cx, d->unit.cx, 4);
	cy = MulDiv(cy, d->unit.cy, 8);

	w = MulDiv(rc.right, d->newScale, d->oldScale);
	h = MulDiv(rc.bottom, d->newScale, d->oldScale);

	rc.left = cx;
	rc.top = cy;
	rc.right = cx + w;
	rc.bottom = cy + h;
	LONG style = GetWindowLong(hWnd, GWL_STYLE);
	LONG exStyle = GetWindowLong(hWnd, GWL_EXSTYLE);
	AdjustWindowRectEx(&rc, style, FALSE, exStyle);
	SetWindowPos(hWnd, NULL, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, SWP_NOZORDER);
	SendMessage(hWnd, WM_SETFONT, (WPARAM)d->hFont, MAKELPARAM(TRUE, 0));
	UpdateWindow(hWnd);
	return TRUE;
}

BOOL GetActualDialogBaseUnits(HWND hDlg, SIZE *baseUnit){
	RECT rect;
	BOOL result;

	rect.left = 4;
	rect.top = 8;
	if (result = MapDialogRect(hDlg, &rect)) {
		baseUnit->cx = rect.left;
		baseUnit->cy = rect.top;
	}
	return result;
}

//	DLL内の関数へのポインタ型を定義
typedef void (WINAPI *RtlGetVersion_FUNC)(OSVERSIONINFOEXW*);

int win10ver2(void){
	int ver = 0;
	HMODULE hMod;
	OSVERSIONINFOEXW osw;
	hMod = LoadLibrary(TEXT("ntdll.dll"));
	RtlGetVersion_FUNC func;
	if (hMod){
		func = (RtlGetVersion_FUNC)GetProcAddress(hMod, "RtlGetVersion");
		if (func == 0){
			FreeLibrary(hMod);
			return FALSE;
		}
		ZeroMemory(&osw, sizeof(osw));
		osw.dwOSVersionInfoSize = sizeof(osw);
		func(&osw);
		FreeLibrary(hMod);
		if (osw.dwMajorVersion == 10){
			switch (osw.dwBuildNumber){
			case 10240: ver = 1507; break;
			case 10586: ver = 1511; break;
			case 14393: ver = 1607; break;
			case 15063: ver = 1703; break;
			case 16299: ver = 1709; break;
			case 17134: ver = 1803; break;
			case 17763: ver = 1809; break;
			default: ver = 1809; break;
			}
			return ver;
		}
	}
	return -1;
}

#endif // WIN10VERDEF < 1703
